extends Spatial

# class member variables go here, for example:
# var a = 2
# var b = "textvar"
var mouse_speed = Vector2()
var speed = 0.2
onready var cam = $Camera
onready var fps = $Camera/Label

func _ready():
	# Called every time the node is added to the scene.
	# Initialization here
	Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
	pass

func _input(event):
	if event is InputEventMouseMotion:
		mouse_speed = event.relative
		
func _process(delta):
	var dir = Vector3()
	
	var aim = cam.get_global_transform().basis
	
	if Input.is_action_pressed("forward"):
		dir -= aim[2]
	if Input.is_action_pressed("backward"):
		dir += aim[2]
	if Input.is_action_pressed("left"):
		dir -= aim[0]
	if Input.is_action_pressed("right"):
		dir += aim[0]
	if Input.is_action_pressed("up"):
		dir += aim[1]
	if Input.is_action_pressed("down"):
		dir -= aim[1]
		
	if Input.is_action_just_pressed("hide_GI"):
		if get_parent().get_node("GIProbe").is_visible_in_tree():
			get_parent().get_node("GIProbe").hide()
		else:
			get_parent().get_node("GIProbe").show()
	#translate(dir.normalized() * speed)
	translation += dir.normalized() * speed
	
	rotate_y(-mouse_speed.x * 0.001)
	cam.rotate_x(-mouse_speed.y * 0.001)
	
	mouse_speed = Vector2()
	
	fps.text = str(Engine.get_frames_per_second())